/** @file
 *
 * QT based network table
 *
 * @author Paul Pantalone
 * @copyright Paul Pantalone. All Rights Reserved
 * @date 2018
 */
#pragma once

#include <QWidget>
#include <qtElements/NetworkTableWidget.h>
#include <qtElements/export.h>

QT_BEGIN_NAMESPACE
class QLineEdit;
QT_END_NAMESPACE

namespace pdp {
class NeuralNetwork;
}

/**
 * @ingroup qtElements
 */
class PDPQTELEMENTS_EXPORT NetworkTable : public QWidget
{
Q_OBJECT

public:
  explicit NetworkTable(
    QWidget* parent);

  ~NetworkTable() override;

  NetworkTableWidget* table()
  { return m_table; }

  void clear();

  void loadTableFromNetwork(
    pdp::NeuralNetwork* network);

  void updateNetworkState(
    pdp::NeuralNetwork* network);

  void clearSelection()
  { m_table->clearSelection(); }

private:
  void setupGUI();

private:
  NetworkTableWidget* m_table;
  QLineEdit* m_stateEdt;
};
