#pragma once

#include <QFont>
#include <QMouseEvent>
#include <QDialog>
#include <qtElements/export.h>

class QPropertyAnimation;

class QTimer;

class PDPQTELEMENTS_EXPORT PropertiesDialog : public QDialog
{
Q_OBJECT

public:
  PropertiesDialog(
    QWidget* parent,
    double opacity);

  ~PropertiesDialog();

  /**
   * Makes the dialog visible
   */
  void setDialogVisible(
    int globalX,
    int globalY,
    int sizeX,
    int sizeY);

  /**
   * Makes the dialog not visible
   */
  void setDialogNotVisible();

public Q_SLOTS:

  void rcvAnimateDialogNotVisible();

private Q_SLOTS:

  void rcvFadeInAnimationFinished();

  void rcvFadeOutAnimationFinished();

protected:
  virtual void enterEvent(
    QEvent* event);

  virtual void leaveEvent(
    QEvent* event);

private:
  double m_opacity;
  bool m_fadeInHold;
  QPropertyAnimation* m_fadeInAnimation;
  QPropertyAnimation* m_fadeOutAnimation;
  QTimer* m_closeTimer;
};
