/** @file
 *
 * Robot rendering widget
 *
 * @author Paul Pantalone
 * @copyright Paul Pantalone. All Rights Reserved
 * @date 2018
 */
#pragma once

#include <QPixmap>
#include <QWidget>
#include <QMouseEvent>
#include <elements/VectorR.h>
#include <models/RobotFactory.h>
#include <render/RayTracingEngine.h>
#include <qtElements/export.h>

namespace pdp {
class ModelR3f;
}

class PDPQTELEMENTS_EXPORT RayTracingWidget : public QWidget
{
Q_OBJECT

public:
  RayTracingWidget(
    pdp::RayTracingEngine* engine,
    pdp::ModelR3f* roomModel,
    QWidget* parent);

  ~RayTracingWidget();

  void render();

protected:
  virtual void paintEvent(
    QPaintEvent* paintEvent) override;

private:
  QPixmap m_pixmap;
  pdp::RayTracingEngine* m_engine;
  pdp::ModelR3f* m_roomModel;
};
